import { world, system} from '@minecraft/server'
import {Guns} from "../Guns.js"
import {ReloadTypes} from "./reloadSystem.js"

export function setMovement (player, item) {
    if (!item) return 
    if (!ReloadTypes.hasOwnProperty(item.typeId) && !Guns.hasOwnProperty(item.typeId)) return
    const typeId = item.typeId.split("_")[0]
    const movement = player.getComponent("movement")
    if (player.isSneaking) {
        const value = Guns[typeId].movementSlowness.sneaking
        if (!value) return
        player.addEffect("slowness", 3, {amplifier: value,  showParticle: false})
    } else {
        const value = Guns[typeId].movementSlowness.hold
        if (!value) return
        player.addEffect("slowness", 3, {amplifier: value,  showParticle: false})
    }
    
    
}
