//By L4ggcrafter
import { world, system, ItemStack} from '@minecraft/server'
import {shoot} from "./gunFunctions/shootProjectile.js"
import {playEffects} from "./gunFunctions/specialEffects.js"
import {PlayerGunsData, setUpGunsData} from "./PlayerGunsData.js"

import {PlayerEquipment} from "./playerComponents.js"
import {reloadGun} from "./gunFunctions/reloadSystem.js"
import {Guns} from "./Guns.js"
world.beforeEvents.itemUse.subscribe(({itemStack, source, useDuration}) => {
    if (Guns.hasOwnProperty(itemStack.typeId)) {
        intializeGun(source, itemStack)
    }
})

world.afterEvents.itemStopUse.subscribe(({itemStack, source, useDuration}) => {

    if (Guns.hasOwnProperty(itemStack.typeId)) {
        onGunStopUse(source, itemStack)
    }
    reloadGun(source, itemStack)
})
function onGunStopUse (player, item) {
    PlayerGunsData[player.id].isUsing = false
    const gunId = item.getDynamicProperty("L4gg-gunId")
    const ammo = PlayerGunsData[player.id].guns[gunId].currentAmmo
    if (ammo > 0) {
        item.setDynamicProperty("L4gg-ammo", ammo)
        PlayerEquipment.setItemHold(player, item)
    } else {
        let emptyGun = new ItemStack (item.typeId+"_empty", 1)
        emptyGun.setDynamicProperty("L4gg-gunId", gunId)
        PlayerEquipment.setItemHold(player, emptyGun)
    }
}
function intializeGun (player, item) {
    setGunId (player, item)
    
    let ammo = item.getDynamicProperty("L4gg-ammo")
    if (ammo == undefined ) {
       // console.warn(JSON.stringify(PlayerGunsData, null, 1))
        ammo = Guns[item.typeId].maxAmmo
        item.setDynamicProperty("L4gg-ammo", ammo)
        system.run(() => {
            PlayerEquipment.setItemHold(player, item)
        })
        
    }
    let gunId = item.getDynamicProperty("L4gg-gunId")
    let isInitialized = PlayerGunsData[player.id]?.guns?.hasOwnProperty(gunId)
    if (!isInitialized) {
        setUpGunsData(player, item, true)
    }
    PlayerGunsData[player.id].isUsing = true
}



export function setGunId (player, item) {
    let itemId = item.getDynamicProperty("L4gg-gunId")
    if (itemId) return
    let id = world.getDynamicProperty("L4gg-gunId") || 0
    id++
    world.setDynamicProperty("L4gg-gunId", id)
    item.setDynamicProperty("L4gg-gunId", id)
   // PlayerEquipment.setItemHold(player, item)
    
}